osgViewer::Renderer Class Reference

`#include <Renderer>`

Inheritance diagram for osgViewer::Renderer:

## Classes

struct | ThreadSafeQueue

## Public Member Functions

| Renderer (osg::Camera *camera)
osgUtil::SceneView * | getSceneView (unsigned int i)
const osgUtil::SceneView * | getSceneView (unsigned int i) const
void | setDone (bool done)
bool | getDone ()
void | setGraphicsThreadDoesCull (bool flag)
bool | getGraphicsThreadDoesCull () const
virtual void | cull ()
virtual void | draw ()
virtual void | cull_draw ()
virtual void | compile ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
void | setCompileOnNextDraw (bool flag)
bool | getCompileOnNextDraw () const
virtual void | operator() (osg::Object *object)
virtual void | operator() (osg::GraphicsContext *context)
virtual void | release ()
virtual void | reset ()
void | setCameraRequiresSetUp (bool flag)
bool | getCameraRequiresSetUp () const
Public Member Functions inherited from osg::GraphicsOperation
| GraphicsOperation (const std::string &name, bool keep)
Public Member Functions inherited from osg::Operation
| Operation (const std::string &name, bool keep)
void | setName (const std::string &name)
const std::string & | getName () const
void | setKeep (bool keep)
bool | getKeep () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

void | initialize (osg::State *state)
virtual | ~Renderer ()
virtual void | updateSceneView (osgUtil::SceneView *sceneView)
Protected Member Functions inherited from osg::Operation
| Operation ()
virtual | ~Operation ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::observer_ptr< osg::Camera > | _camera
bool | _done
bool | _graphicsThreadDoesCull
bool | _compileOnNextDraw
bool | _serializeDraw
osg::ref_ptr< osgUtil::SceneView > | _sceneView [2]
ThreadSafeQueue | _availableQueue
ThreadSafeQueue | _drawQueue
bool | _initialized
osg::ref_ptr< OpenGLQuerySupport > | _querySupport
osg::Timer_t | _startTick
Protected Attributes inherited from osg::Operation
std::string | _name
bool | _keep
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## Renderer()

osgViewer::Renderer::Renderer | ( | osg::Camera * | camera | ) |

## ~Renderer()

virtual osgViewer::Renderer::~Renderer | ( |  | ) |

protected virtual

## Member Function Documentation

## compile()

virtual void osgViewer::Renderer::compile | ( |  | ) |

virtual

## cull()

virtual void osgViewer::Renderer::cull | ( |  | ) |

virtual

## cull_draw()

virtual void osgViewer::Renderer::cull_draw | ( |  | ) |

virtual

## draw()

virtual void osgViewer::Renderer::draw | ( |  | ) |

virtual

## getCameraRequiresSetUp()

bool osgViewer::Renderer::getCameraRequiresSetUp | ( |  | ) | const

## getCompileOnNextDraw()

bool osgViewer::Renderer::getCompileOnNextDraw | ( |  | ) | const

inline

References _compileOnNextDraw.

## getDone()

bool osgViewer::Renderer::getDone | ( |  | ) |

inline

References _done.

## getGraphicsThreadDoesCull()

bool osgViewer::Renderer::getGraphicsThreadDoesCull | ( |  | ) | const

inline

References _graphicsThreadDoesCull.

## getSceneView() [1/2]

osgUtil::SceneView * osgViewer::Renderer::getSceneView | ( | unsigned int | i | ) |

inline

References _sceneView.

## getSceneView() [2/2]

const osgUtil::SceneView * osgViewer::Renderer::getSceneView | ( | unsigned int | i | ) | const

inline

References _sceneView.

## initialize()

void osgViewer::Renderer::initialize | ( | osg::State * | state | ) |

protected

## operator()() [1/2]

virtual void osgViewer::Renderer::operator() | ( | osg::GraphicsContext * | context | ) |

virtual

Implements osg::GraphicsOperation.

## operator()() [2/2]

virtual void osgViewer::Renderer::operator() | ( | osg::Object * | object | ) |

virtual

Override the standard Operation operator and dynamic cast object to a GraphicsContext, on success call operation()(GraphicsContext*).

Reimplemented from osg::GraphicsOperation.

## release()

virtual void osgViewer::Renderer::release | ( |  | ) |

virtual

if this operation is a barrier then release it.

Reimplemented from osg::Operation.

## releaseGLObjects()

virtual void osgViewer::Renderer::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::GraphicsOperation.

## reset()

virtual void osgViewer::Renderer::reset | ( |  | ) |

virtual

## resizeGLObjectBuffers()

virtual void osgViewer::Renderer::resizeGLObjectBuffers | ( | unsigned int |  | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::GraphicsOperation.

## setCameraRequiresSetUp()

void osgViewer::Renderer::setCameraRequiresSetUp | ( | bool | flag | ) |

Force update of state associated with cameras.

## setCompileOnNextDraw()

void osgViewer::Renderer::setCompileOnNextDraw | ( | bool | flag | ) |

inline

References _compileOnNextDraw.

## setDone()

void osgViewer::Renderer::setDone | ( | bool | done | ) |

inline

References _done.

## setGraphicsThreadDoesCull()

void osgViewer::Renderer::setGraphicsThreadDoesCull | ( | bool | flag | ) |

## updateSceneView()

virtual void osgViewer::Renderer::updateSceneView | ( | osgUtil::SceneView * | sceneView | ) |

protected virtual

## Member Data Documentation

## _availableQueue

ThreadSafeQueue osgViewer::Renderer::_availableQueue

protected

## _camera

osg::observer_ptr<osg::Camera> osgViewer::Renderer::_camera

protected

## _compileOnNextDraw

bool osgViewer::Renderer::_compileOnNextDraw

protected

Referenced by getCompileOnNextDraw(), and setCompileOnNextDraw().

## _done

bool osgViewer::Renderer::_done

protected

Referenced by getDone(), and setDone().

## _drawQueue

ThreadSafeQueue osgViewer::Renderer::_drawQueue

protected

## _graphicsThreadDoesCull

bool osgViewer::Renderer::_graphicsThreadDoesCull

protected

Referenced by getGraphicsThreadDoesCull().

## _initialized

bool osgViewer::Renderer::_initialized

protected

## _querySupport

osg::ref_ptr<OpenGLQuerySupport> osgViewer::Renderer::_querySupport

protected

## _sceneView

osg::ref_ptr<osgUtil::SceneView> osgViewer::Renderer::_sceneView[2]

protected

Referenced by getSceneView(), and getSceneView().

## _serializeDraw

bool osgViewer::Renderer::_serializeDraw

protected

## _startTick

osg::Timer_t osgViewer::Renderer::_startTick

protected

The documentation for this class was generated from the following file:

- Renderer